<?php

namespace App\Exports;

use App\Models\Proceso;
use App\Models\ProcesoJudicial;
use Maatwebsite\Excel\Concerns\WithMapping;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Maatwebsite\Excel\Concerns\FromCollection;

class ProcesosJudicialesExport implements FromCollection, WithHeadings, WithMapping
{
    protected $filtros;
    protected $procesos;
    public function __construct($procesos) {
        $this->procesos = $procesos;
    }

    public function collection()
    {
        return $this->procesos;
    }

    public function headings(): array
    {
        return [
            'Código',
            'Descripción',
            'Departamento',
            'Ciudad',
            'Juzgado',
            'Tipo Delito',
            'Tipo Proceso',
            'Estado',
            'Daño Economico',
        ];
    }

    public function map($p): array
    {
        return [
            $p->codigo_proceso,
            $p->descripcion_proceso,
            $p->ciudad->depto_nombre ?? 'N/A',
            $p->ciudad->ciudad_nombre ?? 'N/A',
            $p->juzgado,
            $p->tipo_delito->nombre ?? 'N/A',
            $p->tipo_proceso->nombre ?? 'N/A',
            $p->seguimientos->last()->estado->nombre ?? 'SIN SEGUIMIENTO',
                $p->daño_economico,
        ];
    }
}

